﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.Text;

namespace VisualTreeHelperBug
{
	public partial class MainPage : UserControl
	{
		public MainPage()
		{
			InitializeComponent();

			this.MouseMove += new MouseEventHandler(MainPage_MouseMove);
		}
		void MainPage_MouseMove(object sender, MouseEventArgs e)
		{
			tb.Text = HitTest(e.GetPosition(null));
			if (tb.Text.StartsWith("N"))
			{
				tb.Foreground = new SolidColorBrush(Colors.Black);
			}
			else
			{
				tb.Foreground = new SolidColorBrush(Colors.Red);
			}
		}

		private static string HitTest(Point point)
		{
			var element = VisualTreeHelper.FindElementsInHostCoordinates(point, null).OfType<FrameworkElement>().Where(fe => fe.Name == "border");
			if (element.Any())
			{
				return "Border at " + point;
			}
			else
			{
				return "No Border at " + point;
			}
		}
	}
}